//(function() {
	(function($) {
		$.fn.uploader = function(options) {
            // Private properties
            var self = this,
                defaults = {
					app: myApp,
                    api : apiHost + '/v1/uploader/up?token=',
                };
            /**
             * Sets the options that were required
             *
             * @private
             */
            var setOptions = function () {
                var def;
                options = options || {};
                for (def in defaults) {
                    if (typeof options[def] === 'undefined') {
                        options[def] = defaults[def];
                    }
                }
            }
			// 将原图转化为缩略图并返回
		    var getName = function (picture) {
		        picture = picture.replace(options.host,'');
                sStatus = 0;
                if ((a=picture.split('=')).length>0) {
                    picture = a[0];
                    sStatus = a[1];
                }
		        var aFiles = picture.split('/'),
		            iFilesLength = aFiles.length,
		            sFileName = aFiles[iFilesLength-1],
		            sThumbName = 'thumb_'+sFileName,
                    isRemoteUrl = picture.indexOf('http')>=0;
		        aFiles.pop();
		        aFiles = aFiles.join('/');
		        sFileName = isRemoteUrl ? picture : aFiles + '/' + sFileName;
                sThumbName = isRemoteUrl ? picture : aFiles + '/' + sThumbName;
		        var result = {fileName:sFileName,thumbName:sThumbName};
                if (a.length>0) {
                    result.status = sStatus;
                }
                return result;
		    }
			var addValues = function(obj, picture) {
				var a = getName(picture),
                    ft = a.fileName.substr(a.fileName.lastIndexOf('.')+1),
                    img = '', link='',
                    isRemoteUrl = a.fileName.indexOf('http')>=0;
                if (['png','jpg','jpeg','gif','bmp','svg'].indexOf(ft)<0 && !isRemoteUrl) {
                    link = '<a href="'+options.host+picture+'" class="item-link external"' +
                        ' style="pointer-events:initial">{body}</a>';
                    img = '<img src="../img/filetypes/'+ft+'.png" data-no-image data-src="'+a.fileName+'">';
                } else {
                    link = '';
                    img = '<img src="'+(isRemoteUrl?'':options.host)+a.thumbName+'" data-src="'+a.fileName+'" data-thumb-src="'+a.thumbName+'">';
                }
		        var body = 	'	<i class="icon item-media">' +
		            		'		<span class="badge bg-gray close-files external">✕</span>'+img;
                if (a.status!==undefined) {
                    body += '       <span class="badge bg-gray status-verified external" data-value="'+a.status+'">'+a.status+'</span>';
                }
                    body += '	</i>';
                var html = 	'<li class="close-files-remove img-box">'+(link?link.replace(/(\{body\})/g,body):body)+'</li>';
                $(obj).parent().before(html);
			}
			// 获取附件数据路径,多个并用逗号分隔
		    var setValues = function (objUL) {
		        var values = [];
                $(objUL).find('img').each(function () {
                    var v = $(this).attr('data-src');
                    if ((o=$(this).next('.status-verified')).length>0) {
                        v+='='+o.attr('data-value');
                    }
                    if($(objUL).attr('class').indexOf('change-image')>=0){
                        values = v;
                    }else {
                        values.push(v);
                    }
		        });
                if($(objUL).attr('class').indexOf('change-image')<0){
                    values = values.join(',');
                }
                $(objUL).prev('input[data-type="file"]').val(values).attr('value', values).attr('data-value',values);
		        options.onChange(values);
		    }
            var addClick = function() {
				var self = this;
                new uploader($('input[type="file"]', self)[0], {
                    url: options.api,
                    prefix:'filename',
                    multiple:true,
                    autoUpload:true,
                    error:function(ev){
                        //myApp.alert(JSON.stringify(ev)+attachmentsUploader.oParams.uploadHost);
                    },
                    beforeSend:function () {
                        options.app.showIndicator();
                    },
                    success:function(data){
                        options.app.hideIndicator();
                        data = JSON.parse(data);
                        for (var i in data){
                            addValues(self, data[i].picture)
                        }
                        setValues($(self).parents('ul')[0]);
                    },
                    completes : function () {
                        options.app.hideIndicator();
                    }
                });
            }
            var removeClick = function() {
                var ul = $(this).parents('.attachments-list');
                ul.hasClass('removing') ? ul.removeClass('removing') : ul.addClass('removing');
            }
			var initComponent = function() {
    			self.each( function() {
                    var theinput = this;
                    if ((classname = $(theinput).attr('data-class'))==='no-readonly') {
                        classname = 'col-100';
                    } else {
                        classname = 'col-100 '+options.class+' '+(classname==undefined?'':classname);
                    }
					//如果加过了，就不要再加
                    if (options.reinit) {
                        $('.attachments-list').remove();
                    }
					if ($(theinput).next('.attachments-list').length>0) return;
					var s =	'<ul class="row attachments-list '+classname+'">'+
							'	<li class="choose">'+
							'		<div class="button file-button choose-attachments">'+
							'			+<input name="filename[]" type="file" multiple="multiple" accept="*/*"/>'+
							'		</div>'+
							'	</li>'+
							'	<li class="choose">'+
							'		<div class="button file-button remove-attachments">'+
							'			-'+
							'		</div>'+
							'	</li>'+
							'</ul>';
                    $(this).parent().append(s)
                        .find('.choose-attachments').on('click', addClick)
                        .parents('ul').find('.remove-attachments').on('click', removeClick);
                    // $(theinput).parent().find('.remove-attachments').on('click', removeClick);
					if ((a=$(this).attr('data-value'))!==undefined && (a!=='') && (b=a.split(',')).length>0) {
						for(var i in b) {
							addValues($('.choose-attachments', $(theinput).next('ul'))[0], b[i]);
						};
					}
                    // 移除附件
                    $(document).off('click','.attachments-list img').on('click', '.close-files', function () {
						var ul = $(this).parents('ul')[0];
                        $(this).parents('.close-files-remove').remove();
                        setValues(ul);
                    });

                    // 预览附件
                    $(document).off('click','.attachments-list img:not([data-no-image])').on('click','.attachments-list img:not([data-no-image])',function () {
                        var thisSrc = options.host + $(this).attr('data-src'),
                            photos=[];
                        var ft = thisSrc.substr(thisSrc.lastIndexOf('.')+1);
                        if (['png','jpg','jpeg','gif','bmp','svg'].indexOf(ft)>=0)
                            photos = [thisSrc];

                        $(".attachments-list").find('img').each(function () {
                            var src = options.host + $(this).attr('data-src');
                            ft = src.substr(src.lastIndexOf('.')+1);
                            if (src != thisSrc && ['png','jpg','jpeg','gif','bmp','svg'].indexOf(ft)>=0)
                                photos.push(src);
                        });
                        options.app.photoBrowser({
                            photos : photos,
                            backLinkText: '关闭',
                            theme: 'dark',
                            type: 'standalone'
                        }).open();
                    });
                    /*
                    $(document).off('click', '.remove-attachments').on('click', '.remove-attachments', function(){
                        var ul = $(this).parents('.attachments-list');
                        ul.hasClass('removing') ? ul.removeClass('removing') : ul.addClass('removing');
                    });
                    */
                    $(document).off('click', '.status-verified').on('click', '.status-verified', function() {
                        $(this).attr('data-value', $(this).attr('data-value')==1 ? 0 : 1);
                        var ul = $(this).parents('.attachments-list');
                        setValues(ul);
                    });
                    // if ($(this).attr('data-auto-open')==='true') {
                    //     $(this).parent().find('.choose-attachments input').click();
                    // }
    			});
			}

			var methods = {
				init : function() {
                    setOptions();
					initComponent();
				}
			};
            return methods.init.apply(this, arguments);
			// if (methods[method]) {
			// 	return methods[method].apply(this, Array.prototype.slice.call(arguments, 1));
			// }
			// if (typeof method === "object" || !method) {
			// 	return methods.init.apply(this, arguments);
			// }
			// return $.error("Method " + method + " does not exist!");
		};
		return this;
	})(jQuery);
//}).call(this);
