/*此文件由hsj维护*/
myApp.onPageInit('page-city', function (page) {
    if (!(
        (objContent = $$(page.container).find('#tab1 .content-list')).length != 0 &&
        (content = objContent[0].innerHTML).length != '' &&
        (dataset = $$(page.container).dataset()).length != 0 &&
        (dataset.return !== undefined) &&
        (returns = JSON.parse(dataset.return)).length != 0
    )) return;

    var render = function (data, content) {
        var result = { "list": JSON.parse(data), "query": page.query };
        var template = Template7.compile(content);
        return template(result);
    }

    var loadCity = function (api, prefix, callback) {
        var level = api.indexOf('/province') > 0 ? 0 : api.indexOf('/city') > 0 ? 1 : api.indexOf('/area') > 0 ? 2 : 3;
        var config = [{ type: 'province' }, { type: 'city' }, { type: 'area' }, { type: 'street' }];
        if (level >= config.length) return;
        myApp.showIndicator();
        $$(page.container).find('#tab' + (level + 1) + ' .content-list').html('<div class="content-block row ks-preloaders text-center"><div class="col-100"><span class="preloader"></span></div></div>');
        ajaxGet(api, function (data) {
            myApp.hideIndicator();
            $$(page.container).find('#tab' + (level + 1) + ' .content-list').html(render(data, content));
            $$(page.container).find('#tab' + (level + 1) + ' .label-radio').on('change', function () {
                var data = {
                    code: $$(this).find('input[name="ks-media-radio"]').val(),
                    name: (prefix == '' ? '' : prefix + ' ') + $$(this).find('.item-title').text()
                };
                if (page.query._return == config[level].type) {
                    $$(page.fromPage.container).find('input[name="listener"]').trigger('change', {
                        input: returns.inputName,
                        value: data.code,
                        text: data.name,
                        data: data,
                        fromurl: page.url
                    });
                    myApp.getCurrentView().router.back();
                } else {
                    $$(page.container).find('#tab' + (level + 1)).removeClass('active');
                    $$(page.container).find('#tab' + (level + 2)).addClass('active');
                    callback !== undefined ? callback(data) : null;
                }
            });

        }, false, true);
    }
    objContent.html('<div class="content-block row ks-preloaders text-center"><div class="col-100"><span class="preloader"></span></div></div>');
    setTimeout(function () {
        loadCity('/v1/cities/province', '', function (data) {
            loadCity('/v1/cities/city?province=' + data.code.substr(0, 2), data.name, function (data) {
                loadCity('/v1/cities/area?city=' + data.code, data.name, function (data) {
                });
            });
        });
    }, 500);
});

//动态改变印刷名片盒数量
function changeQuantity(obj, data) {
    $$(obj).parent('div').find("input[name='quantity']").val(data);
    $$(obj).parent('div').find('.button').removeClass('active');
    $$(obj).addClass('active');
}

//绑定【一键受理】按钮事件
var oneProcess = function (page) {
    var _href = window.location.href.substr(1);

    // formid
    var formid = _href.match(new RegExp("(^|&)formid=([^&]*)(&|$)"));
    formid = formid != null ? decodeURI(formid[2]) : null;

    // type
    var type = _href.match(new RegExp("(^|&)type=([^&]*)(&|$)"));
    type = type != null ? decodeURI(type[2]) : null;

    if (!(formid && type)) return;

    var api = "/v1/formrequests/" + formid + "?type=" + type;

    var actionHsj = [
        [
            {
                text: '请选择受理操作的动作',
                label: true
            },
            {
                text: '通过',
                onClick: function () {
                    ajaxPut(api, 'status=1', function (data) {
                        myApp.getCurrentView().router.back();
                        myApp.pullToRefreshTrigger();
                    });

                }
            },
            {
                color: 'red',
                text: '不通过',
                onClick: function () {
                    ajaxPut(api, 'status=2', function (data) {
                        myApp.getCurrentView().router.back();
                        myApp.pullToRefreshTrigger();
                    });
                }
            },
        ],
        // Second group
        [
            {
                text: '取消',
                bold: true
            }
        ]
    ];
    myApp.actions(actionHsj);
}

myApp.onPageInit('page-voucher-form', function (page) {
    $$(page.container).find('.button-save').removeClass('color-blue').addClass('disabled color-gray');
    if ((page.query.type === 'BQ' || page.query.id !== undefined)) {
        $$(page.container).find('.page-content').addClass('detail-form-hidden');
    }
    binder.initPages(page, function (result) {
        var _validate = function (page) {
            var result = { return: true, errors: {} };
            $$.each($$(page.container).find('#detail-form').find('input[data-required="true"],select[data-required="true"]'), function (i, e) {
                // console.log($$(e).attr('name')+'='+$$(e).val());
                result.return = result.return && ($$(e).val() != '');
                $$(e).val() == '' ? result.errors[$$(e).attr('name')] = $$(e).parents('li').find('.item-title').html() + '不能为空' : null;
            });
            if (['BQ','SQ','CQ','CB','IQ'].indexOf(page.query.type)<0) { // page.query.type!='IQ'
                var v1 = parseFloat($$(page.container).find("input[name='subtotal']").val().replace(/[,]/g, '')),
                    v2 = parseFloat((o = $$(page.container).find("input[name='totallimit']")).length > 0 ? o.val().replace(/[,]/g, '') : 0);
                // console.log('v1='+v1+',v2='+v2);
                // v2=parseFloat($$(page.container).find("select[name='chargeid']").val().replace(/[,]/g,''));
                v1 = isNaN(v1) ? 0.0 : v1; v2 = isNaN(v2) ? 0.0 : v2;
                // if (v1 > v2) {
                //     result.return = false;
                //     var title = '提示：已超出预算金额';
                //     var tip = title + ' <span class="unit-rmb">' + fnFormatNumber(v1 - v2) + '</span>';
                //     $$(page.container).find('.warning').css('display', '').addClass('color-red').html(tip);
                // }
            }
            return result;
        }
        var validate = function (page) {
            if (!_validate(page).return) {
                $$(page.container).find('.button-save').removeClass('color-blue').addClass('disabled color-gray');
            } else {
                $$(page.container).find('.button-save').removeClass('disabled color-gray').addClass('color-blue');
            }
        }
        /*<<<<<<<<<<<把下面的代码
        if (result.handleForm !== undefined) {
            primarykey = result.handleForm.page.query.id;
        } else primarykey = 0;
        if (result.handleListener !== undefined) {
            //添加科目完成后，将单位一并自动写入
            $$(page.container).find('input[name="upid"]').val(result.handleListener.event.detail.data.voucherid);
            $$(page.container).find('.upid').html(result.handleListener.event.detail.data.voucherid);

        }
         $$('input[name="subtotal"]').on('change', function () {
         validate(page);
         var obj = $$('.detail-form');
         var quantity = parseFloat(obj.find("input[name='quantity']").val().replace(/[,]/g, '')),
         subtotal = parseFloat(obj.find("input[name='subtotal']").val().replace(/[,]/g, '')),
         value = (isNaN(quantity) || isNaN(subtotal)) ? 0.00 : (subtotal / quantity).toFixed(2);
         value = fnFormatNumber(value);
         obj.find("input[name='price']").val(value).attr('value',value);
         });
        改为下面的代码>>>>>>>>>>>>>*/
        // 加载表单后的回调
        if (result.handleForm !== undefined) {
            // 获取新的键值
            var primarykey = result.handleForm.page.query.id;
            // 改变隐藏字段的值
            if ((hiddenObj = $$(page.container).find('#detail-form .hidden-div')).length > 0) {
                hiddenObj.html('<input type="hidden" name="voucherid" value="'+primarykey+'">');
            }
            // 改变明细列表api
            if ((detailList = $$(page.container).find('.detail-list')).length > 0) {
                detailList.attr('data-api', '/v1/voucherdetails?voucherid='+primarykey+'&amp;sortby=id&amp;order=desc');
            }
            // 数字键盘改变后的回调，value就是数字键盘输入值
            result.handleForm.loadNumber = function(p, value) {
                $$('.detail-form').find("input[name='"+$$(p.input).attr('name')+"']").val(value).attr('data-value',value).attr('value',value);
                if (page.query.type!='IQ') {
                    // 计算小计
                    var subtotal = $$(p.input).attr('name')=='subtotal' ? value : parseFloat($$('.detail-form').find("input[name='subtotal']").val().replace(/[,]/g, '')),
                        quantity = $$(p.input).attr('name')=='quantity' ? value : parseFloat($$('.detail-form').find("input[name='quantity']").val().replace(/[,]/g, '')),
                        price = (isNaN(subtotal) || isNaN(quantity)) ? 0.00 : (subtotal / quantity).toFixed(2);
                    // console.log('subtotal:'+subtotal+',quantity='+quantity+',price='+price);
                    $$('.detail-form').find("input[name='price']").val(price).attr('value', price).attr('data-value',price);
                }
                // 触发按钮
                validate(page);
            }
        } else {
            var primarykey = 0;
        }
        if (result.handleRefresh !== undefined ) {
            // 有明细才更新总金额，没明细不更新，因为有时就是只输入总金额的情况
            if ((data = result.handleRefresh.data).errcode===undefined) {
                var total = 0.0;
                for( var i in data ) {
                    total+=parseFloat(data[i].subtotal);
                }
                total = isNaN(total) ? 0 : total;
                total = fnFormatNumber(total.toFixed(2));
                $$(page.container).find('input[name="total"]').val(total).attr('data-value',total).attr('value',total);
                binder.initSubmit(page);
            }

        }
        /*修改结束<<<<<<<<<<<<<<<<<*/

        if ((detailtitle = $$(page.container).find('.detail-title')).length > 0) {
            var template = Template7.compile(detailtitle[0].outerHTML);
            detailtitle[0].outerHTML = template(page);
        }
        if ((detailform = $$(page.container).find('.detail-form')).length > 0) {
            var template = Template7.compile(detailform.attr('class'));
            detailform.attr('class', template(page));
            var othercoid = $$(page.container).find('input[name="othercoid"]').val();
            var selectApi = page.query.type === 'CC' ? '/v1/contractdetails?by=contract&type=purchase&othercoid=' + othercoid : '/v1/chargexs';
            var oldApi = (chargeObj = detailform.find('select[name="chargeid"]')).attr('data-api');
            chargeObj.attr('data-api', selectApi);
            selectApi !== oldApi && chargeObj.empty() && binder.initSelect(page);
            page.query.type !== 'CC' && detailform.find('.limit-panel').remove();
        }
        if (page.query.type=='IQ' && (panel = $$(page.container).find('#detail-form .subtotal-panel')).length > 0) {
            panel.remove();
        }
        if (page.query.type=='IQ' && (panel = $$(page.container).find('#detail-form .price-panel')).length > 0) {
            panel.remove();
        }
        if ((hidden = $$(page.container).find('#detail-form .hidden-div')).length > 0) {
            var template = Template7.compile(hidden[0].innerHTML);
            if (result.handleForm !== undefined) {
                hidden.html(template(result.handleForm.page));
            } else {
                if (result.handleListener !== undefined) {
                    hidden.html(template(result.handleListener.page));
                }
            }

        }
        if ((detailcontainer = $$(page.container).find('.detail-container')).length > 0) {
            var template = Template7.compile(detailcontainer.attr('class'));
            detailcontainer.attr('class', template(page));
        }
        //合同预算界面，明细必填，不需要隐藏
        if (page.query.type != 'CQ' && page.name == 'page-voucher-form') {
            $(document).off('click', '.input-panel').on('click', '.input-panel', function(){
                if ((o = $$(page.container).find('.page-content')).hasClass('detail-form-hidden')) {
                    o.removeClass('detail-form-hidden');
                } else {
                    o.addClass('detail-form-hidden');
                }
            });
            /*
            $$(page.container).find('.input-panel').on('click', function () {
                if ((o = $$(page.container).find('.page-content')).hasClass('detail-form-hidden')) {
                    o.removeClass('detail-form-hidden');
                } else {
                    o.addClass('detail-form-hidden');
                }
                // $$(page.container).find('.detail-form').css('display',$$(this).find('input[type="checkbox"]').prop('checked') ? 'block' : 'none');
            });
            */
        } else {
            $$(page.container).find('.page-content').removeClass('detail-form-hidden');
            $('.input-panel').hide();
        }
        $$('select[name="unit"]').on('change', function () {
            validate(page);
            var obj = $$('.detail-form');
            var quantity = isNaN(q = parseFloat(obj.find("input[name='quantity']").val().replace(/[,]/g, ''))) ? 1 : q,
                subtotal = page.query.type!='IQ' ? parseFloat(obj.find("input[name='subtotal']").val().replace(/[,]/g, '')) : 0,
                value = (isNaN(quantity) || isNaN(subtotal)) ? 0.00 : (subtotal / quantity).toFixed(2);
            value = fnFormatNumber(value);
            // obj.find("input[name='price']").val(value).attr('value',value);
            if ($('select[name="unit"]').val() == '混合') {
                obj.find("input[name='price']").val( page.query.type!='IQ' ? obj.find("input[name='subtotal']").val() : 0).attr('value', subtotal);
            } else if ($('select[name="unit"]').val() == '') {
                obj.find("input[name='price']").val('').attr('value', '');
            } else {
                obj.find("input[name='price']").val(value).attr('value', value);
            }
        });
        $(document).off('click','.button-save').on('click','.button-save',function () {
            //找到新建明细表单
            var form = $$('.detail-form');
            var oldid=0, chargeid='', unit='', price=0, quantity=0, subtotal=0;
            //获取coucherid参数
//			var _href =window.location.href.substr(1);
//			voucherid = _href.match(new RegExp("(^|&)id=([^&]*)(&|$)"));
//		    voucherid = voucherid != null ? decodeURI(voucherid[2]) : null;
            //获取chargeid参数
            chargeid = document.getElementsByName('chargeid')[0].value;
            unit = document.getElementsByName('unit')[0].value;
            //获取price参数
            price = page.query.type!='IQ' ? document.getElementsByName('price')[0].value : 0;
            //获取quantity参数
            quantity = document.getElementsByName('quantity')[0].value;
            //获取subtotal参数
            subtotal = page.query.type!='IQ' ? document.getElementsByName('subtotal')[0].value : 0;
            //保存时不需要判断max了，在输入时已经验证。由验证不过仍可提交，所以这里不需要，但如果验证不过不可提交，则服务端也应该判断。
            // max = document.getElementsByName('max')[0].value;

            var formDS = form.dataset();
            var url = fnReplaceFromQuery(formDS.api, page.query, primarykey);
            //	form.html('');
            var success = function (data) {
                var data = JSON.parse(data);
                if (data.errcode != undefined && [40006, 40004].indexOf(data.errcode) != -1) {
                    myApp.alert(data.errmsg);
                    return false;
                }
                //		viewWork.router.refreshPage();
                $$(page.container).find('select[name="chargeid"]').val('').attr('value', '').attr('data-value', '').next().find('.item-after').html('请选择类别');
                $$(page.container).find('select[name="unit"]').val('').attr('value', '').attr('data-value', '').css('color', 'gray');
                $$(page.container).find('input[name="price"]').val('').attr('value', '').attr('data-value', '');
                $$(page.container).find('input[name="quantity"]').val('').attr('value', '').attr('data-value', '');
                $$(page.container).find('input[name="subtotal"]').val('').attr('value', '').attr('data-value', '');
                for (var i in keypads) {
                    i.indexOf(page.name) >= 0 && keypads[i].setValue('');
                }
                // document.getElementsByName('chargeid')[0].value='';
                // document.getElementsByName('unit')[0].value='';
                // document.getElementsByName('price')[0].value='';
                // document.getElementsByName('quantity')[0].value='';
                // document.getElementsByName('subtotal')[0].value='';
                //获取用户此次操作所获得的的积分
                ajaxGet('/v1/employees/current', function (data) {
                    data = JSON.parse(data);
                    var msg = data.score !== 0 ? '<img src="../img/coin.png" style="height: 30px;"><span class="color-yellow" style="font-weight:bold"> + ' + data.score + '</span> 积分' : '提交成功';
                    binder.showIndicator(msg, 1500);
                }, false);

                myApp.pullToRefreshTrigger($$('.pull-to-refresh-content'));
                var a = '/v1/voucherdetails?voucherid=';
                ajaxGet(a + page.query.id, function (data) {
                    var t = 0.0;
                    data = JSON.parse(data);
                    for (var i = 0; i < data.length; i++) {
                        t += parseFloat(data[i].subtotal);
                    }
                    t = fnFormatNumber(t.toFixed(2));
                    (o = $$('input[name="total"]')).length > 0 && o.val(t).attr('value', t);
                    (o = $$('input[name="amount"]')).length > 0 && o.val(t).attr('value', t);
                    binder.initSubmit(page);
                });
                validate(page);
            };
            var data = 'oldid=' + oldid + '&' +
                'chargeid=' + chargeid + '&' +
                'unit=' + unit + '&' +
                'price=' + price + '&' +
                'quantity=' + quantity + '&' +
                'subtotal=' + subtotal;
            data += '&voucherid=' + primarykey;
            ajaxPost(url, data, success);
        });

        $$('.button-import-hsj').on('click', function () {
            var self = this;
            var oldHtml = $$(self).text();
            $$(self).addClass('disabled').html('<span class="preloader-container"><span class="preloader"></span>正在导入...</span>');
            var api = $$(self).attr('data-api');
            ajaxGet(api, function (data) {
                data = JSON.parse(data);
                if (data.errcode == '40004'){
                    $$(self).removeClass('disabled').html(oldHtml);
                    myApp.alert('未找到通过审核的'+oldHtml.substring(4));
                }
                $$(page.container).find('input[name="issuetime"]').val(data.issuetime).attr('data-value', data.issuetime);
                $$(page.container).find('input[name="total"]').val(data.total).attr('data-value', data.total);
                $$(page.container).find('input[name="documents"]').val(data.documents).attr('data-value', data.documents);
                binder.initUploader(page, true);
                $$(page.container).find('.pull-to-refresh-content').trigger('refresh');
                $(self).html('<span class="icon"><i class="f7-icons">check_round_fill</i>导入成功！</span>').parent().delay(1500).slideUp(500);
                binder.initSubmit(page);
                // setTimeout(function(){
                // 	var template = $$('form').html();
                // 	console.log(template);
                // 	var compiledTemplate = Template7.compile(template);
                // 	$$('form').html(compiledTemplate(data));
                // },2000);

            }, false);
        })
    });
});

/*myApp.onPageBeforeInit('page-contract-form', function(page){
    var template = Template7.compile($$(page.container).find('.form-container').html());
    $$(page.container).find('.form-container').html(template(page));
});*/
myApp.onPageInit('page-contract-form', function (page) {
    $$(page.container).find('.button-save').removeClass('color-blue').addClass('disabled color-gray');
    if (page.query.id !== undefined) {
        $$(page.container).find('.page-content').addClass('detail-form-hidden');
    }
    binder.initPages(page, function (result) {
        if (result.handleForm !== undefined) {
            primarykey = result.handleForm.page.query.id;
        } else primarykey = 0;
        if (result.handleListener !== undefined) {
            //添加科目完成后，将单位一并自动写入
            $$(page.container).find('input[name="upid"]').val(result.handleListener.event.detail.data.voucherid);  
            $$(page.container).find('.upid').html(result.handleListener.event.detail.data.voucherid); 

        }
        if ((detailtitle = $$(page.container).find('.detail-title')).length > 0) {
            var template = Template7.compile(detailtitle[0].outerHTML);
            detailtitle[0].outerHTML = template(page);
        }
        if ((detailform = $$(page.container).find('.detail-form')).length > 0) {
            var template = Template7.compile(detailform.attr('class'));
            detailform.attr('class', template(page));
        }
        if ((hidden = $$(page.container).find('#detail-form .hidden-div')).length > 0) {
            var template = Template7.compile(hidden[0].innerHTML);
            if (result.handleForm !== undefined) 
                {
                    hidden.html(template(result.handleForm.page));
                }
                else{
                    if (result.handleListener !== undefined) {
                        hidden.html(template(result.handleListener.page));
                    }
                }

            }
            if ((detailcontainer = $$(page.container).find('.detail-container')).length > 0) {
                var template = Template7.compile(detailcontainer.attr('class'));
                detailcontainer.attr('class', template(page));
            }
            if (page.name === 'page-contract-form' && page.query._inputfield != 'file_3' && page.query._inputfield != 'file_3,file_4') {
                // && page.query._inputfield=='file_1,file_2' && page.query.status==0
                (o = $$(page.container).find('.detail-container')).length > 0 && o.show();
            }
            //编译detailList部分  这个不能加上去，不然会在下拉刷新的地方显示项目名称
            //var template = Template7.compile((o=$$(result.handleForm.container).find('.detail-list')).html()),
            //	content = o.find('.content-list').html();
            //o.html('').html('<span class="preloader"></span>');
            //o.html(template(result.handleForm));
            //o.find('.content-list').html(content);
            //binder.initRefresh(result.handleForm);

            var _validate = function (page) {
                var result = { return: true, errors: {} };
                $$.each($$(page.container).find('#detail-form').find('input[data-required="true"],select[data-required="true"]'), function (i, e) {
                    result.return = result.return && ($$(e).val() != '');
                    $$(e).val() == '' ? result.errors[$$(e).attr('name')] = $$(e).parents('li').find('.item-title').html() + '不能为空' : null;
                });
				if (page.query.type!='IQ') {
					var v1 = parseFloat($$(page.container).find("input[name='subtotal']").val().replace(/[,]/g, '')),
						v2 = parseFloat((o = $$(page.container).find("input[name='totallimit']")).length > 0 ? o.val().replace(/[,]/g, '') : 0);
				}
                // v2=parseFloat($$(page.container).find("select[name='chargeid']").val().replace(/[,]/g,''));
                if (page.name == 'page-contract-form' && (v1 > v2)) {
                    result.return = false;
                    var title = '提示：已超出预算金额';
                    var tip = title + ' <span class="unit-rmb">' + fnFormatNumber(v1 - v2) + '</span>';
                    $$(page.container).find('.warning').css('display', '').addClass('color-red').html(tip);
                }
				return result;
            }
            var validate = function (page) {
                if (!_validate(page).return) {
                    $$(page.container).find('.button-save').removeClass('color-blue').addClass('disabled color-gray');
                } else {
                    $$(page.container).find('.button-save').removeClass('disabled color-gray').addClass('color-blue');
                }
            }
            //合同预算界面，明细必填，不需要隐藏
            $$(page.container).find('.page-content').removeClass('detail-form-hidden');
            $('.input-panel').hide();
            $$('select[name="unit"]').on('change', function () {
                validate(page);
                var obj = $$('.detail-form');
                var quantity = isNaN(q = parseFloat(obj.find("input[name='quantity']").val().replace(/[,]/g, ''))) ? 1 : q,
                    subtotal = page.query.type!='IQ' ? parseFloat(obj.find("input[name='subtotal']").val().replace(/[,]/g, '')) : 0,
                    value = (isNaN(quantity) || isNaN(subtotal)) ? 0.00 : (subtotal / quantity).toFixed(2);
                value = fnFormatNumber(value);
                // obj.find("input[name='price']").val(value).attr('value',value);
                if ($('select[name="unit"]').val() == '混合') {
                    obj.find("input[name='price']").val( page.query.type!='IQ' ? obj.find("input[name='subtotal']").val() : 0).attr('value', subtotal);
                } else if ($('select[name="unit"]').val() == '') {
                    obj.find("input[name='price']").val('').attr('value', '');
                } else {
                    obj.find("input[name='price']").val(value).attr('value', value);
                }
            });
            $$('input[name="subtotal"]').on('change', function () {
                validate(page);
                var obj = $$('.detail-form');
                var quantity = parseFloat(obj.find("input[name='quantity']").val().replace(/[,]/g, '')),
                    subtotal = parseFloat(obj.find("input[name='subtotal']").val().replace(/[,]/g, '')),
                    value = (isNaN(quantity) || isNaN(subtotal)) ? 0.00 : (subtotal / quantity).toFixed(2);
                value = fnFormatNumber(value);
		    obj.find("input[name='price']").val(value).attr('value',value);
		});
        $(document).off('click','.button-save').on('click','.button-save',function () {
			//找到新建明细表单
			var form = $$('.detail-form');
			var oldid=0, chargeid='', unit='', price=0, quantity=0, subtotal=0;
			//获取coucherid参数
//			var _href =window.location.href.substr(1);
//			voucherid = _href.match(new RegExp("(^|&)id=([^&]*)(&|$)"));
//		    voucherid = voucherid != null ? decodeURI(voucherid[2]) : null;
			//获取chargeid参数
			chargeid = document.getElementsByName('chargeid')[0].value;
            unit = document.getElementsByName('unit')[0].value;
			//获取price参数
			price = page.query.type!='IQ' ? document.getElementsByName('price')[0].value : 0;
			//获取quantity参数
			quantity = document.getElementsByName('quantity')[0].value;
			//获取subtotal参数
			subtotal = page.query.type!='IQ' ? document.getElementsByName('subtotal')[0].value : 0;
			//保存时不需要判断max了，在输入时已经验证。由验证不过仍可提交，所以这里不需要，但如果验证不过不可提交，则服务端也应该判断。
            // max = document.getElementsByName('max')[0].value;

                var formDS = form.dataset();
                var url = fnReplaceFromQuery(formDS.api, page.query, primarykey);
                //	form.html('');
                var success = function (data) {
                    var data = JSON.parse(data);
                    if (data.errcode != undefined && [40006, 40004].indexOf(data.errcode) != -1) {
                        myApp.alert(data.errmsg);
                        return false;
                    }
                    //		viewWork.router.refreshPage();
                    $$(page.container).find('select[name="chargeid"]').val('').attr('value', '').attr('data-value', '').next().find('.item-after').html('请选择类别');
                    $$(page.container).find('select[name="unit"]').val('').attr('value', '').attr('data-value', '').css('color', 'gray');
                    $$(page.container).find('input[name="price"]').val('').attr('value', '').attr('data-value', '');
                    $$(page.container).find('input[name="quantity"]').val('').attr('value', '').attr('data-value', '');
                    $$(page.container).find('input[name="subtotal"]').val('').attr('value', '').attr('data-value', '');
                    for (var i in keypads) {
                        i.indexOf(page.name) >= 0 && keypads[i].setValue('');
                    }
                    // document.getElementsByName('chargeid')[0].value='';
                    // document.getElementsByName('unit')[0].value='';
                    // document.getElementsByName('price')[0].value='';
                    // document.getElementsByName('quantity')[0].value='';
                    // document.getElementsByName('subtotal')[0].value='';
                    //获取用户此次操作所获得的的积分
                    ajaxGet('/v1/employees/current', function (data) {
                        data = JSON.parse(data);
                        var msg = data.score !== 0 ? '<img src="../img/coin.png" style="height: 30px;"><span class="color-yellow" style="font-weight:bold"> + ' + data.score + '</span> 积分' : '提交成功';
                        binder.showIndicator(msg, 1500);
                    }, false);

                    myApp.pullToRefreshTrigger($$('.pull-to-refresh-content'));
                    //
                    var a = (page.name == 'page-contract-form') ? '/v1/contractdetails?contractid=' : '/v1/voucherdetails?voucherid=';
                    ajaxGet(a + page.query.id, function (data) {
                        var t = 0.0;
                        data = JSON.parse(data);
                        for (var i = 0; i < data.length; i++) {
                            t += parseFloat(data[i].subtotal);
                        }
                        t = fnFormatNumber(t.toFixed(2));
                        (o = $$('input[name="amount"]')).length > 0 && o.val(t).attr('value', t);
                        binder.initSubmit(page);
                    });
                    validate(page);
                };
                var data = 'oldid=' + oldid + '&' +
                    'chargeid=' + chargeid + '&' +
                    'unit=' + unit + '&' +
                    'price=' + price + '&' +
                    'quantity=' + quantity + '&' +
                    'subtotal=' + subtotal;
                data += '&contractid=' + primarykey;
                ajaxPost(url, data, success);
            });

            $$('.button-import-hsj').on('click', function () {
                var self = this;
                var oldHtml = $$(self).text();
                $$(self).addClass('disabled').html('<span class="preloader-container"><span class="preloader"></span>正在导入...</span>');
                var api = $$(self).attr('data-api');
                ajaxGet(api, function (data) {
                    data = JSON.parse(data);
                    if (data.errcode == '40004'){
                        $$(self).removeClass('disabled').html(oldHtml);
                        myApp.alert('未找到通过审核的'+oldHtml.substring(4));
                    }
                    $$(page.container).find('input[name="issuetime"]').val(data.issuetime).attr('data-value', data.issuetime);
                    $$(page.container).find('input[name="total"]').val(data.total).attr('data-value', data.total);
                    $$(page.container).find('input[name="documents"]').val(data.documents).attr('data-value', data.documents);
                    binder.initUploader(page, true);
                    $$(page.container).find('.pull-to-refresh-content').trigger('refresh');
                    $(self).html('<span class="icon"><i class="f7-icons">check_round_fill</i>导入成功！</span>').parent().delay(1500).slideUp(500);
                    binder.initSubmit(page);
                    // setTimeout(function(){
                    // 	var template = $$('form').html();
                    // 	console.log(template);
                    // 	var compiledTemplate = Template7.compile(template);
                    // 	$$('form').html(compiledTemplate(data));
                    // },2000);

                }, false);
            })
        });
});

myApp.onPageInit('page-projectpay', function (page) {
    var calendarDefault = myApp.calendar({
        input: '#calendar-default',
        onDayClick: function () { calendarDefault.close(); },
    });
});

myApp.onPageInit('page-expenserequest-form',function(page){
    //单独提取受理记录进行编译,先获取受理记录的数据
    var api = $$(page.container).find('form').attr('data-api') + (page.query.id!==undefined? '/'+ page.query.id : '');
    var timeline = $$(page.container).find('.timeline');
    var template = timeline.html();
    timeline.html('');
    var compiledTemplate = Template7.compile(template);
    binder.initPages(page, function(result){
        //数据获取成功后编译受理记录内容
        ajaxGet(api, function (datas) {
            datas = JSON.parse(datas);
            var data ={
                data: datas
            };
            timeline.html(compiledTemplate(data));
        });
        var template = Template7.compile((o=$$(result.handleForm.page.container).find('.detail-list')).html()),
            content = o.find('.content-list').html();
        o.html('');
        o.html(template(result.handleForm.page));
        o.find('.content-list').html(content);
        binder.initRefresh(result.handleForm.page, undefined, function(){
            $$(result.handleForm.page.container).find('.detail-list').removeClass('preloader-loading');
        });
    }, ['refresh']);
});

/*
myApp.onPageInit('page-expense-form',function(page){
	binder.initPages(page, function(result){
		var voucherid = result.handleForm.query.id;
		var template = Template7.compile((hidden = $$(page.container).find('#detail-form-expense .hidden-div'))[0].innerHTML);
		hidden.html(template(result.handleForm));
		var template = Template7.compile((title = $$(page.container).find('.detail-title'))[0].outerHTML);
		title[0].outerHTML = template(page);

		$$(page.container).find('.label-switch').on('change', function(){
	        $$(this).find('input[type="checkbox"]').prop('checked') ? $$(page.container).find('.page-content').removeClass('detail-form-hidden') : $$(page.container).find('.page-content').addClass('detail-form-hidden');
	        // $$(page.container).find('.detail-form').css('display',$$(this).find('input[type="checkbox"]').prop('checked') ? 'block' : 'none');
	    });
		$$('.button-save').on('click',function(e){
			//找到新建明细表单
			var form = $$('.detail-form');
			var price=0, quantity=0;
			//获取coucherid参数
//			var _href =window.location.href.substr(1);
//			voucherid = _href.match(new RegExp("(^|&)id=([^&]*)(&|$)"));
//		    voucherid = voucherid != null ? decodeURI(voucherid[2]) : null;
			//获取金额参数
			total = document.getElementsByName('total')[0].value;
			//获取费用类型参数
			type = document.getElementsByName('type')[0].value;
			//获取url
			var formDS = form.dataset();
			var url = fnReplaceFromQuery(formDS.api, page.query, voucherid);
			var data = 	'oldid=' + oldid + '&'+
						'voucherid=' + voucherid + '&'+
						'chargeid=' + chargeid + '&'+
						'price=' + price + '&'+
						'quantity=' + quantity + '&'+
						'subtotal=' + subtotal;
			var success = function(data){
				var data = JSON.parse(data);
				if(data.errcode != undefined && [40006,40004].indexOf(data.errcode) != -1){
	                myApp.alert(data.errmsg);
	                return false;
		    	}
		//		viewWork.router.refreshPage();
				document.getElementsByName('total')[0].value='';
				document.getElementsByName('type')[0].value='';
				myApp.pullToRefreshTrigger($$('.pull-to-refresh-content'));
			};
			ajaxPost(url, data, success);
		});
	});
});
*/

myApp.onPageInit('page-corporation-form', function (page) {
    binder.initPages(page, function (res) {
        //判断输入内容,数字+字母
        $$('input[name="taxpayerno"]').on('keyup', function (event) {
            $$(this).val($$(this).val().replace(/[^0-9a-zA-Z]/g, ''));
        });
    });
});

myApp.onPageInit('page-fileuploader', function (page) {
    binder.initNavbar(page);
    ajaxPut('/v1/employees/current', 'setter=checkcode', function (data) {
        data = JSON.parse(data);
        $$(page.container).find('.checkcode').html(data.checkcode);
        $$(page.container).find('.uploadurl').html(appHost == 'http://ddapp' ? 'ddapp' : 'm.gongchengjia.cn');
        $$(page.container).find('.button-done').on('click', function () {
            ajaxGet('/v1/uploader?checkcode=' + data.checkcode, function (data) {
                data = JSON.parse(data);
                if (data.errcode) {
                    myApp.getCurrentView().router.back();
                    return;
                }
                var value = text = '';
                for (var i in data) {
                    value += (value ? ',' : '') + data[i].attachment;
                }
                var fromPage = (fPage = myApp.getCurrentView().container.children[0].firstElementChild.f7RelatedPage) != undefined ? fPage.f7PageData : myApp.getCurrentView();
                $$(fromPage.container).find('input[name="listener"]').trigger('change', {
                    input: page.query._inputname !== undefined ? page.query._inputname : 'documents',
                    value: value,
                    text: text,
                    data: data,
                    fromurl: page.url //decodeURIComponent(page.url)
                });
                myApp.getCurrentView().router.back();
            });
        });
    });

});


//页面初始化时page-content会被binder取出编译,所以这里要在初始化之前把我需要的内容编译进去,再执行默认初始化
myApp.onPageBeforeInit('page-employee-select', function (page) {
    binder.initPages(page);
    ajaxGet('/v1/departments', function (data) {
        var parent = $$(page.container).find('.accordion-item-content');
        var compiledTemplate = Template7.compile(parent.html());
        data = { departments: JSON.parse(data), query: page.query };
        parent.html(compiledTemplate(data));
    }, false);//此处必须同步，否则部门无法显示出来
})
//切换部门时,显示当前部门下的人员
/*
var changeDepartment = function (did,a) {
	myApp.accordionClose('.accordion-item');//关闭手风琴效果
	var self = $(a).parents('.pull-to-refresh-content');
	var dname = $(a).find('.item-title').text();
	$(a).parents('.accordion-item').find('.item-title').first().html(dname);//改变文字为当前部门
	did = (did===0)?'':'departmentid='+did;//如果选择全部，则不加参数，否则加上部门id
	$$(self).attr('data-api', '/v1/departments/list?'+did);//改变api后触发下拉刷新
	myApp.pullToRefreshTrigger($$(self));
}

var hsjSelect = function(a,groupid){
	var page = $$($$('div[data-page="page-add-employee"]')[1]);
	// if ($(a).hasClass('hsjOver')){
    if ((o=page.find('.content-list')).hasClass('selectable-opened')) {
		//完成选择后,提交选中数据,改变groupid
		// $(a).removeClass('hsjOver');
		// $(a).text('选择');
        o.removeClass('selectable-opened');
        $$(a).html('<span>选择</span>');

		// $(page).find('.item-media').next().hide();
		// $(page).find('a').css('pointer-events','all');
		// $(page).find('label a').show();
		// $(page).find('label i:first-child').animate({left:'-50px',opacity:0},500,function () {
		// 	$(this).hide();
		// });
		// $(page).find('label i:last-child').animate({left:'0',opacity:1},500);
		var adds = [];
		$$.each(page.find('input[name="addEmployee"]:checked'), function (i,e) {
			adds.push($(e).val());
			e.checked = false;
			$(e).parents('li').slideUp(500);
		});
		if (adds.length <= 0)
			return;
		_changeGroupid(adds,groupid);
		myApp.getCurrentView().router.back();
	}else{
		//右上角选择按钮点击时,显示多选框
        o.addClass('selectable-opened');
        $$(a).html('<span>完成</span>');
		// $(a).addClass('hsjOver');
		// $(a).text('完成');
		// $(page).find('.item-media').next().show();
		// $(page).find('a').css('pointer-events','none');
		// $(page).find('label a').hide();
		// $(page).find('label i:first-child').animate({left:'12px',opacity:1},500).show();
		// $(page).find('label i:last-child').animate({left:'+50px',opacity:0},500);
	}
}
//删除人员,只是改变groupid=50
var hsjDelet = function (a) {
	myApp.confirm('确认从此角色删除此人么?',function () {
		$(a).parents('li').slideUp(500);
		_changeGroupid($(a).parents('li').attr('data-key'),50);
	})
}
//自定义方法,方便调用
var _changeGroupid = function (data,groupid) {
	if (data instanceof Array){
		data = data.join(',');
	}
	ajaxPost('/v1/authorization/grant','employeeid='+data+'&groupid='+groupid,function (data) {
		var fromPage = (fPage = myApp.getCurrentView().container.children[0].firstElementChild.f7RelatedPage) != undefined ? fPage.f7PageData : myApp.getCurrentView();
		fromPage= $$(fromPage.container)[0].f7View.activePage.fromPage.container;
		myApp.pullToRefreshTrigger($(fromPage).find('.page-content'));
	});
}
*/
Template7.registerHelper('js_radio', function (orginValue, compareValue, name) {
    if (orginValue == compareValue) {
        return '<input name="' + name + '" value="' + orginValue + '" type="radio" checked="true"/>';
    } else {
        return '<input name="' + name + '" value="' + orginValue + '" type="radio"/>';
    }
});

//hsj 结束